typedef union {
    long	num;
    u_long	u_num;
    bytestr	hex;
    charstr	str;
    flag_t	flag;
    time_t	time;
    as_t	as;
    proto_t	proto;
    pmet_t	metric;
    pref_t	pref;
    if_addr	*ifap;
    if_addr_entry	*ifae;
    adv_entry	*adv;
    gw_entry	*gwp;
    void_t	vt;
    sockaddr_un	*sockaddr;
#ifdef	PROTO_INET
    struct in_addr in_addr;
#endif	/* PROTO_INET */
    dest_mask	dm;
    struct {
	pmet_t metric;
	adv_entry *adv;
    } metric_adv ;
    struct {
	proto_t proto;
	adv_entry **import_list;
	adv_entry **export_list;
	gw_entry **gw_list;
    } proto_lists;
    config_entry *config;
    config_list *conflist;
#ifndef	GATED_LEXER
#ifdef	PROTO_OSPF
    ospf_config_router *ospf_router;
#endif	/* PROTO_OSPF */
#if	defined(PROTO_ASPATHS)
    asmatch_t	*asp_match;
    struct {
	u_short	begin;
	u_short end;
    } asp_range;
    struct {
	flag_t	start[1 + ASP_ACC/ASP_WORD];
	flag_t	state[1 + ASP_ACC/ASP_WORD];
    } asp_stack;
#endif	/* PROTO_ASPATHS */
#endif	/* GATED_LEXER */
} YYSTYPE;
#define	L_EOS	258
#define	L_ERROR	259
#define	L_NUMBER	260
#define	L_STRING	261
#define	L_HNAME	262
#define	L_KEYWORD	263
#define	L_HEXSTRING	264
#define	L_OCTETSTRING	265
#define	T_DIRECT	266
#define	T_INTERFACE	267
#define	T_INTERFACES	268
#define	T_LCLADDR	269
#define	T_PROTO	270
#define	T_METRIC	271
#define	T_METRICIN	272
#define	T_METRICOUT	273
#define	T_INFINITY	274
#define	T_DOWN	275
#define	T_PARSE	276
#define	T_ADV	277
#define	T_DEFAULT	278
#define	T_DEFAULTS	279
#define	T_YYDEBUG	280
#define	T_YYSTATE	281
#define	T_YYQUIT	282
#define	T_DEBUG	283
#define	T_SYSLOG	284
#define	T_UPTO	285
#define	T_EMERG	286
#define	T_ALERT	287
#define	T_CRIT	288
#define	T_ERR	289
#define	T_WARNING	290
#define	T_NOTICE	291
#define	T_INFO	292
#define	T_ON	293
#define	T_OFF	294
#define	T_GATEWAY	295
#define	T_PREFERENCE	296
#define	T_DEFAULTMETRIC	297
#define	T_NONBROADCAST	298
#define	T_BROADCAST	299
#define	T_TYPE	300
#define	T_POINTOPOINT	301
#define	T_MULTICAST	302
#define	T_NETMASK	303
#define	T_DEFINE	304
#define	T_NOP	305
#define	T_NOP1	306
#define	T_PEERAS	307
#define	T_LOCALAS	308
#define	T_NEIGHBOR	309
#define	T_GROUP	310
#define	T_NOGENDEFAULT	311
#define	T_VERSION	312
#define	T_DEFAULTIN	313
#define	T_DEFAULTOUT	314
#define	T_MAXUP	315
#define	T_SOURCENET	316
#define	T_PKTSIZE	317
#define	T_P1	318
#define	T_P2	319
#define	T_BGP	320
#define	T_HOLDTIME	321
#define	T_TEST	322
#define	T_KEEPALL	323
#define	T_SENDBUF	324
#define	T_RECVBUF	325
#define	T_SPOOLBUF	326
#define	T_EGP	327
#define	T_ASPATH	328
#define	T_ORIGIN	329
#define	T_INCOMPLETE	330
#define	T_ANY	331
#define	T_TAG	332
#define	T_TRUSTEDGATEWAYS	333
#define	T_SOURCEGATEWAYS	334
#define	T_RIP	335
#define	T_NORIPOUT	336
#define	T_NORIPIN	337
#define	T_NOCHECKZERO	338
#define	T_NOHELLOOUT	339
#define	T_NOHELLOIN	340
#define	T_AREA	341
#define	T_SPF	342
#define	T_HELLO	343
#define	T_HELLOINTERVAL	344
#define	T_ROUTERDEADINTERVAL	345
#define	T_PRIORITY	346
#define	T_REDIRECT	347
#define	T_NOREDIRECTS	348
#define	T_ICMP	349
#define	T_AUTHTYPE	350
#define	T_AUTHKEY	351
#define	T_NONE	352
#define	T_SIMPLE	353
#define	T_AUTH	354
#define	T_PASSIVE	355
#define	T_SIMPLEX	356
#define	T_STRICTIFS	357
#define	T_SCANINTERVAL	358
#define	T_STATIC	359
#define	T_MARTIANS	360
#define	T_RETAIN	361
#define	T_EXPORT	362
#define	T_IMPORT	363
#define	T_HOST	364
#define	T_MASK	365
#define	T_MASKLEN	366
#define	T_REJECT	367
#define	T_BLACKHOLE	368
#define	T_RESTRICT	369
#define	T_ALLOW	370
#define	T_AS	371
#define	T_ROUTERID	372
#define	T_IGP	373
#define	T_OPTIONS	374
#define	T_NOINSTALL	375
#define	T_NOSEND	376
#define	T_NORESOLV	377
#define	T_TRACEOPTIONS	378
#define	T_EXCEPT	379
#define	T_TRACEFILE	380
#define	T_REPLACE	381
#define	T_SIZE	382
#define	T_FILES	383
#define	T_K	384
#define	T_M	385
#define	T_ALL	386
#define	T_GENERAL	387
#define	T_INTERNAL	388
#define	T_EXTERNAL	389
#define	T_ROUTE	390
#define	T_UPDATE	391
#define	T_KERNEL	392
#define	T_TASK	393
#define	T_TIMER	394
#define	T_NOSTAMP	395
#define	T_MARK	396
#define	T_INET	397
#define	T_GENDEFAULT	398


extern YYSTYPE yylval;
